#include <Time.h>
#include <TimeLib.h>
#include <DS1307RTC.h>
#include <Wire.h>
#include "Cmd.h"

#define BAUD 57600

time_t t;
tmElements_t tm;

void setup() {
  //setup VCC and GND on a3, a2, SDA and CLK a4, a5
  pinMode(16, OUTPUT);
  digitalWrite(16, LOW);
  pinMode(17, OUTPUT);
  digitalWrite(17, HIGH);

  Serial.begin(57600);
  Serial.print("DS1307RTC setting utility\n");
  Serial.print("-------------------------\n\n");
  cmdInit();
  cmdAdd("setrtc", srtc);
  cmdAdd("getrtc", grtc);
  while (!Serial) ; // wait for serial
  delay(1000);
  cmdPoll();
  }
  
void loop() {
  cmdPoll();
  delay(1000);
}

void print2digits(int number) {
  if (number >= 0 && number < 10) {
    Serial.print('0');
  }
  Serial.print(number);
}

void srtc(int arg_cnt, char **args){
int yyyy,mm,dd,h,m,s;
sscanf(args[1],"%4d%2d%2d%2d%2d%2d",&yyyy,&mm,&dd,&h,&m,&s);
tm.Year=yyyy-1970;
tm.Month=mm;
tm.Day=dd;
tm.Hour=h;
tm.Minute=m;
tm.Second=s;
tm.Year=yyyy-1970;
t = makeTime(tm);
RTC.set(t);        //use the time_t value to ensure correct weekday is set
setTime(t);        
}

void grtc(int arg_cnt, char **args){
if (RTC.read(tm)) {
  Serial.print("RTC: (HH:MM:SS) ");
  print2digits(tm.Hour);
  Serial.write(':');
  print2digits(tm.Minute);
  Serial.write(':');
  print2digits(tm.Second);
  Serial.print(" (YYYY/MM/DD) ");
  Serial.print(tmYearToCalendar(tm.Year));
  Serial.write('/');
  print2digits(tm.Month);
  Serial.write('/');
  print2digits(tm.Day);
  Serial.println();
  }
  else{
    if (RTC.chipPresent()){
      Serial.println("The DS1307 is stopped.  Please run the SetTime");
      Serial.println("example to initialize the time and begin running.");
      Serial.println();
      }
    else{
      Serial.println("DS1307 read error!  Please check the circuitry.");
      Serial.println();
      }
    }
}
